from django.conf.urls import url
from trunk.views import competitions as tv
import branch.views.competitions as comp_views
from forms.views import manage_rubrics


urlpatterns = [

    url(r'^list$',
        tv.ManageCompetitions.as_view(), name='uni-manage-competitions'),
    url(r'^create',
        tv.CreateCompetition.as_view(), name='uni-create-competition'),
    url(r'^(?P<event_id>[^/]+)/edit$',
        tv.EditCompetition.as_view(), name='uni-edit-competition'),
    url(r'^(?P<event_id>[^/]+)/questions$',
        tv.ManageQuestions.as_view(), name='uni-edit-competition-question'),
    url(r'^(?P<event_id>[^/]+)/rubrics$',
        manage_rubrics, name='uni-edit-competition-rubrics'),
    url(r'^(?P<event_id>[^/]+)/judges$',
        tv.CreateJudgeBoard.as_view(), name='uni-edit-competition-judges'),
    url(r'^(?P<event_id>[^/]+)/(?P<board_id>[^/]+)/invite_judge/(?P<judge_id>[^/]+)$',
        comp_views.send_judge_invitations, name='send-single-comp-judge-invite'),
    url(r'^(?P<event_id>[^/]+)/(?P<board_id>[^/]+)/invite_judges$',
        comp_views.send_judge_invitations, name='send-all-comp-judge-invites'),
    url(r'^(?P<event_id>[^/]+)/dashboard$',
        tv.ManageCompetitionsView.as_view(), name='uni-manage-comps-view'),
    url(r'^(?P<event_id>[^/]+)/judge_progress$',
        tv.ViewJudges.as_view(), name='uni-manage-comp-judge-progress'),
    url(r'^(?P<event_id>[^/]+)/judge_progress/(?P<judge_id>[^/]+)$',
        tv.ViewJudgeReview.as_view(), name='uni-manage-comp-judge-review'),
    url(r'^(?P<event_id>[^/]+)/archive_judge$',
        comp_views.archive_judge, name='uni-archive-comp-judge'),
    url(r'^(?P<event_id>[^/]+)/send_feedback$',
        comp_views.send_feedback_to_applicants, name='uni-send-comp-judge-feedback'),
    url(r'^(?P<event_id>[^/]+)/participants$',
        tv.ViewApps.as_view(), name='uni-manage-participants'),
    url(r'^(?P<event_id>[^/]+)/participants/(?P<app_url_name>[^/]+)$',
        tv.ViewApplication.as_view(), name='uni-view-entry'),
    url(r'^(?P<event_id>[^/]+)/bulk_message_participants',
        comp_views.bulk_message_applicants, name='uni-bulk-message-participants'),
    url(r'^(?P<event_id>[^/]+)/customize_emails$',
        tv.CustomizeCompetitionEmails.as_view(), name='uni-edit-comp-emails'),
    url(r'^(?P<event_id>[^/]+)/export/participants$',
        tv.ExportApplication.as_view(), name='uni-export-all-entries'),
    url(r'^(?P<event_id>[^/]+)/export/participants/(?P<app_url_name>[^/]+)$',
        tv.ExportApplication.as_view(), name='uni-export-single-entry'),
    url(r'^(?P<event_id>[^/]+)/export/participants/judge/(?P<judge_id>[^/]+)$',
        tv.ExportApplication.as_view(), name='uni-export-all-judge-entries'),
    url(r'^(?P<event_id>[^/]+)/export/participants/(?P<app_url_name>[^/]+)/attachments$',
        tv.ExportCompAttachments.as_view(), name='uni-export-all-comp-attachments'),
    # not used for now
    # url(r'^(?P<event_id>[^/]+)/export/attachments/judge/(?P<judge_id>[^/]+)$',
    #     tv.ExportCompAttachments.as_view(), name='uni-export-all-judge-comp-attachments'),
    url(r'^(?P<event_id>[^/]+)/template$',
        tv.GenerateCompFromTemplate.as_view(), name='competition-generate-template'),
    url(r'^(?P<event_id>[^/]+)/reorder_questions$',
        tv.ApplicationQuestionReorder.as_view(), name='uni-reorder-comp-questions'),
    url(r'^(?P<event_id>[^/]+)/reorder_rubric$',
        tv.ApplicationRubricReorder.as_view(), name='uni-reorder-comp-rubric'),
    url(r'^(?P<event_id>[^/]+)/submit_participant/(?P<app_url_name>[^/]+)$',
        tv.AdminSubmitApplicant.as_view(), name='uni-submit-participant'),
    url(r'^export/(?P<event_id>[^/]+)$',
        tv.ExportCompetition.as_view(), name='uni-export-competition'),
    url(r'^delete',
        tv.DeleteCompetition.as_view(), name='uni-delete-competition'),
    url(r'^form/(?P<event_id>[^/]+)$',
        comp_views.show_competition_application, name='competition-form'),
    # allow admins to view and edit submitted applications
    url(r'^form/(?P<event_id>[^/]+)/member/(?P<sm_applicant_id>[^/]+)$',
        comp_views.show_competition_application, name='competition-form-admin-sm'),
    url(r'^form/(?P<event_id>[^/]+)/guest/(?P<anon_applicant_id>[^/]+)$',
        comp_views.show_competition_application, name='competition-form-admin-anon'),
    url(r'^enter/(?P<event_id>[-@\w]+)/member/(?P<sm_applicant_id>[^/]+)$',
        comp_views.competition_apply, name='competition-enter-admin-sm'),
    url(r'^enter/(?P<event_id>[-@\w]+)/guest/(?P<anon_applicant_id>[^/]+)$',
        comp_views.competition_apply, name='competition-enter-admin-anon'),
]
